<?xml version="1.0" encoding="iso-8859-1"?> 
<xsl:stylesheet 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:xsd="http://www.w3.org/2001/XMLSchema"
	version="1.0">

<xsl:output method="xml" encoding="UTF-8"/>

<xsl:strip-space elements="*"/>
	
	<xsl:template match="xsd:element[xsd:element]">
		<xsd:element>
			<xsl:copy-of select="@*"/>
			<xsl:choose>
				<xsl:when test="@name='ArchiveTransfer'">
					<xsl:apply-templates select="xsd:element[@name='Comment']"/>
					<xsl:apply-templates select="xsd:element[@name='Date']"/>
					<xsl:apply-templates select="xsd:element[@name='RelatedTransferReference']"/>
					<xsl:apply-templates select="xsd:element[@name='TransferIdentifier']"/>
					<xsl:apply-templates select="xsd:element[@name='TransferRequestReplyIdentifier']"/>
					<xsl:apply-templates select="xsd:element[@name='ArchivalAgency']"/>
					<xsl:apply-templates select="xsd:element[@name='TransferringAgency']"/>
					<xsl:apply-templates select="xsd:element[@name='Archive']"/>
					<xsl:apply-templates select="xsd:element[@name='NonRepudiation']"/>
				</xsl:when>
				<xsl:when test="AccessRestrictionRule">
					<xsl:apply-templates select="xsd:element[@name='Code']"/>
					<xsl:apply-templates select="xsd:element[@name='StartDate']"/>
				</xsl:when>
				<xsl:when test="@name='Address'">
					<xsl:apply-templates select="xsd:element[@name='BlockName']" />
					<xsl:apply-templates select="xsd:element[@name='BuildingName']" />
					<xsl:apply-templates select="xsd:element[@name='BuildingNumber']" />
					<xsl:apply-templates select="xsd:element[@name='CityName']" />
					<xsl:apply-templates select="xsd:element[@name='CitySub-DivisionName']" />
					<xsl:apply-templates select="xsd:element[@name='Country']" />
					<xsl:apply-templates select="xsd:element[@name='FloorIdentification']" />
					<xsl:apply-templates select="xsd:element[@name='Postcode']" />
					<xsl:apply-templates select="xsd:element[@name='PostOfficeBox']" />
					<xsl:apply-templates select="xsd:element[@name='RoomIdentification']" />
					<xsl:apply-templates select="xsd:element[@name='StreetName']" />
				</xsl:when>
				<xsl:when test="@name='AppraisalRule'">
					<xsl:apply-templates select="xsd:element[@name='Code']" />
					<xsl:apply-templates select="xsd:element[@name='Duration']" />
					<xsl:apply-templates select="xsd:element[@name='StartDate']" />
				</xsl:when>
				<xsl:when test="@name='Archive'">
					<xsl:apply-templates select="xsd:element[@name='ArchivalAgencyArchiveIdentifier']" />
					<xsl:apply-templates select="xsd:element[@name='ArchivalAgreement']" />
					<xsl:apply-templates select="xsd:element[@name='ArchivalProfile']" />
					<xsl:apply-templates select="xsd:element[@name='DescriptionLanguage']" />
					<xsl:apply-templates select="xsd:element[@name='Name']" />
					<xsl:apply-templates select="xsd:element[@name='OriginatingAgencyArchiveIdentifier']" />
					<xsl:apply-templates select="xsd:element[@name='ServiceLevel']" />
					<xsl:apply-templates select="xsd:element[@name='TransferringAgencyArchiveIdentifier']" />
					<xsl:apply-templates select="xsd:element[@name='ContentDescription']" />
					<xsl:apply-templates select="xsd:element[@name='AccessRestrictionRule']" />
					<xsl:apply-templates select="xsd:element[@name='AppraisalRule']" />
					<xsl:apply-templates select="xsd:element[@name='ArchiveObject']" />
					<xsl:apply-templates select="xsd:element[@name='Document']" />
				</xsl:when>
				<xsl:when test="@name='ArchiveObject'">
					<xsl:apply-templates select="xsd:element[@name='ArchivalAgencyObjectIdentifier']" />
					<xsl:apply-templates select="xsd:element[@name='Name']" />
					<xsl:apply-templates select="xsd:element[@name='OriginatingAgencyObjectIdentifier']" />
					<xsl:apply-templates select="xsd:element[@name='TransferringAgencyObjectIdentifier']" />
					<xsl:apply-templates select="xsd:element[@name='ContentDescription']" />
					<xsl:apply-templates select="xsd:element[@name='AccessRestrictionRule']" />
					<xsl:apply-templates select="xsd:element[@name='AppraisalRule']" />
					<xsl:apply-templates select="xsd:element[@name='ArchiveObject']" />
					<xsl:apply-templates select="xsd:element[@name='Document']" />
				</xsl:when>
				<xsl:when test="@name='Communication'">
					<xsl:apply-templates select="xsd:element[@name='Channel']" />
					<xsl:apply-templates select="xsd:element[@name='CompleteNumber']" />
					<xsl:apply-templates select="xsd:element[@name='URIID']" />
				</xsl:when>
				<xsl:when test="@name='Contact'">
					<xsl:apply-templates select="xsd:element[@name='DepartmentName']" />
					<xsl:apply-templates select="xsd:element[@name='Identification']" />
					<xsl:apply-templates select="xsd:element[@name='PersonName']" />
					<xsl:apply-templates select="xsd:element[@name='Responsibility']" />
					<xsl:apply-templates select="xsd:element[@name='Address']" />
					<xsl:apply-templates select="xsd:element[@name='Communication']" />
				</xsl:when>
				<xsl:when test="@name='ContentDescription'">
					<xsl:apply-templates select="xsd:element[@name='Description']" />
					<xsl:apply-templates select="xsd:element[@name='DescriptionLevel']" />
					<xsl:apply-templates select="xsd:element[@name='FilePlanPosition']" />
					<xsl:apply-templates select="xsd:element[@name='Language']" />
					<xsl:apply-templates select="xsd:element[@name='LatestDate']" />
					<xsl:apply-templates select="xsd:element[@name='OldestDate']" />
					<xsl:apply-templates select="xsd:element[@name='OtherDescriptiveData']" />
					<xsl:apply-templates select="xsd:element[@name='AccessRestrictionRule']" />
					<xsl:apply-templates select="xsd:element[@name='CustodialHistory']" />
					<xsl:apply-templates select="xsd:element[@name='Keyword']" />
					<xsl:apply-templates select="xsd:element[@name='OriginatingAgency']" />
					<xsl:apply-templates select="xsd:element[@name='OtherMetadata']" />
					<xsl:apply-templates select="xsd:element[@name='RelatedObjectReference']" />
					<xsl:apply-templates select="xsd:element[@name='Repository']" />
				</xsl:when>
				<xsl:when test="@name='Keyword'">
					<xsl:apply-templates select="xsd:element[@name='KeywordContent']" />
					<xsl:apply-templates select="xsd:element[@name='KeywordReference']" />
					<xsl:apply-templates select="xsd:element[@name='KeywordType']" />
					<xsl:apply-templates select="xsd:element[@name='AccessRestrictionRule']" />
				</xsl:when>
				<xsl:when test="@name='Document'">
					<xsl:apply-templates select="xsd:element[@name='ArchivalAgencyDocumentIdentifier']" />
					<xsl:apply-templates select="xsd:element[@name='Attachment']" />
					<xsl:apply-templates select="xsd:element[@name='Control']" />
					<xsl:apply-templates select="xsd:element[@name='Copy']" />
					<xsl:apply-templates select="xsd:element[@name='Creation']" />
					<xsl:apply-templates select="xsd:element[@name='Description']" />
					<xsl:apply-templates select="xsd:element[@name='Integrity']" />
					<xsl:apply-templates select="xsd:element[@name='Issue']" />
					<xsl:apply-templates select="xsd:element[@name='Language']" />
					<xsl:apply-templates select="xsd:element[@name='OriginatingAgencyDocumentIdentifier']" />
					<xsl:apply-templates select="xsd:element[@name='Purpose']" />
					<xsl:apply-templates select="xsd:element[@name='Receipt']" />
					<xsl:apply-templates select="xsd:element[@name='Response']" />
					<xsl:apply-templates select="xsd:element[@name='Size']" />
					<xsl:apply-templates select="xsd:element[@name='Status']" />
					<xsl:apply-templates select="xsd:element[@name='Submission']" />
					<xsl:apply-templates select="xsd:element[@name='TransferringAgencyDocumentIdentifier']" />
					<xsl:apply-templates select="xsd:element[@name='Type']" />
					<xsl:apply-templates select="xsd:element[@name='OtherMetadata']" />
					<xsl:apply-templates select="xsd:element[@name='RelatedData']" />
				</xsl:when>
				<xsl:when test="@name='Organization'">
					<xsl:apply-templates select="xsd:element[@name='BusinessType']" />
					<xsl:apply-templates select="xsd:element[@name='Description']" />
					<xsl:apply-templates select="xsd:element[@name='Identification']" />
					<xsl:apply-templates select="xsd:element[@name='LegalClassification']" />
					<xsl:apply-templates select="xsd:element[@name='Name']" />
					<xsl:apply-templates select="xsd:element[@name='Address']" />
					<xsl:apply-templates select="xsd:element[@name='Communication']" />
					<xsl:apply-templates select="xsd:element[@name='Contact']" />
				</xsl:when>
				<xsl:when test="@name='RelatedData'">
					<xsl:apply-templates select="xsd:element[@name='Data']" />
					<xsl:apply-templates select="xsd:element[@name='Relation']" />
					<xsl:apply-templates select="xsd:element[@name='RelatedData']" />
				</xsl:when>
				<xsl:when test="@name='RelatedObjectReference'">
					<xsl:apply-templates select="xsd:element[@name='RelatedObjectIdentifier']" />
					<xsl:apply-templates select="xsd:element[@name='Relation']" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:apply-templates/>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:copy-of select="xsd:attribute"/>
			<xsl:copy-of select="xsd:annotation"/>
		</xsd:element>
	</xsl:template>
	
	<xsl:template match="xsd:element[not(xsd:element)]">
		<xsl:copy-of select="."/>
	</xsl:template>

</xsl:stylesheet>
		